@ECHO OFF
ECHO OFF
GOTO Begin
REM
REM     Program          :  ChkLabel.bat
REM
REM     Version          :  1.22
REM     Started on       :  September 28, 2008
REM     Completed on     :  September 28, 2008
REM
REM     Description      :  Check labels of a batch.
REM
REM     Required modules :  ChkLbCfg.bat, FileUtil.bat, StrUtil.bat
REM     Dos required     :  Windows 95 or later
REM
REM     Notes - usage    :  See help (/? parameter)
REM                         Setting DEBUG environment variable to "Y", enable
REM                         on-screen commands echoing
REM     References       :  None
REM
REM     Authors          :  J.Hubb - planning
REM                         J.Hubb - programming
REM                         J.Hubb - debug session
REM     Authors address  :  J.Hubb
REM                         Indigo skyline
REM                         A'DAAR channel
REM

:Begin
IF "%DEBUG%" == "Y" ECHO ON
IF "%1" == "[]ENVPREPARED[]" GOTO Start
%COMSPEC% /E:4096 /C %0 []ENVPREPARED[] %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO End

:Start
SET NAME=%0
SHIFT
ECHO.
ECHO ChkLabel.bat 1.22; freeware on September 28, 2008 by J.Hubb.

:ChkCmdLine
IF "%1" == "" GOTO Help
SET CL_TARGET=
IF "%2" == "/T" SET CL_TARGET=Y
IF "%2" == "/t" SET CL_TARGET=Y
IF "%CL_TARGET%" == "" IF NOT "%2" == "" GOTO Help
IF NOT "%3" == "" GOTO Help

:LoadCfg
SET CL_TMP=
IF EXIST %NAME%\..\ChkLbCfg.bat CALL %NAME%\..\ChkLbCfg.bat
IF NOT "%CL_TMP%" == "" GOTO EndLC
CALL ChkLbCfg.bat
IF "%CL_TMP%" == "" GOTO NoCfgErr
:EndLC

:ChkLib
SET CL_TMP=
CALL StrUtil Ver CL_TMP
IF "%CL_TMP%" == "" GOTO NoStrUtilErr
SET CL_TMP=
CALL FileUtil Ver CL_TMP
IF "%CL_TMP%" == "" GOTO NoFileUtilErr

:ChkFile
IF NOT EXIST %1 GOTO NotFound

:CreateTmpFiles
CALL FileUtil NewFileName %TMP% CL tmp CL_TMP
SET CL_TMP=%CL_TMP%> %TMP%\%CL_TMP%Orig.tmp
SET CL_TMP=%CL_TMP%> %TMP%\%CL_TMP%Sort.tmp
SET CL_TMP=%CL_TMP%> %TMP%\%CL_TMP%NoSp.tmp
SET CL_TMP=%CL_TMP%> %TMP%\%CL_TMP%Uniq.tmp
SET CL_TMP=%CL_TMP%> %TMP%\%CL_TMP%Uniq8.tmp
SET CL_TMP=%CL_TMP%> %TMP%\%CL_TMP%Targ.tmp

:GetLabels
ECHO   Total labels:
GREP -i "^( |	)*@*(	| )*:." < %1 | STRKEEP AFTER ":" > %TMP%\%CL_TMP%.tmp
STRTRIM " " RIGHT < %TMP%\%CL_TMP%.tmp | STRTRIM "$09" RIGHT > %TMP%\%CL_TMP%Orig.tmp
SORT < %TMP%\%CL_TMP%Orig.tmp | STRCASE LOWER > %TMP%\%CL_TMP%Sort.tmp
WC -l < %TMP%\%CL_TMP%Orig.tmp

:ShowSpaces
ECHO   Labels with spaces:
GREP " " < %TMP%\%CL_TMP%Sort.tmp | STRINS 1 "    "

:ShowDup
ECHO   Duplicated labels:
STRINS 255 " " < %TMP%\%CL_TMP%Sort.tmp | STRKEEP BEFORE " " > %TMP%\%CL_TMP%NoSp.tmp
UNIQ -d < %TMP%\%CL_TMP%NoSp.tmp | STRINS 1 "    "

:Show8Dup
ECHO   Duplicated labels on 8 chars:
UNIQ < %TMP%\%CL_TMP%NoSp.tmp > %TMP%\%CL_TMP%Uniq.tmp
STRSUB 1 8 < %TMP%\%CL_TMP%Uniq.tmp > %TMP%\%CL_TMP%.tmp
UNIQ -d < %TMP%\%CL_TMP%.tmp | STRINS 1 "    "
UNIQ < %TMP%\%CL_TMP%.tmp > %TMP%\%CL_TMP%Uniq8.tmp

:ShowGotosTargets
IF NOT "%CL_TARGET%" == "Y" GOTO DelTmpFiles
ECHO   Unexistent GOTO's targets:
GREP -iv "^( |	)*@*(	| )*(ECHO|REM|:)" < %1 | GREP -i ".*GOTO +[^ ]" > %TMP%\%CL_TMP%Targ.tmp
STRKEEP AFTER "GOTO" /I < %TMP%\%CL_TMP%Targ.tmp | STRREPL "$09" " " > %TMP%\%CL_TMP%.tmp
STRTRIM " " LEFT < %TMP%\%CL_TMP%.tmp | STRINS 255 " " > %TMP%\%CL_TMP%Targ.tmp
STRKEEP BEFORE " " < %TMP%\%CL_TMP%Targ.tmp | STRCASE LOWER > %TMP%\%CL_TMP%.tmp
SORT < %TMP%\%CL_TMP%.tmp | UNIQ > %TMP%\%CL_TMP%Targ.tmp
CALL FileUtil ReadTextRow Open %TMP%\%CL_TMP%Targ.tmp CL_STAT
:SGTLoop
SET CL_ROW=12345789012345789012345789012
CALL FileUtil ReadTextRow Next %CL_STAT% CL_ROW
IF "%CL_STAT%" == "EOF" GOTO SGTEnd
FIND /I "%CL_ROW%" < %TMP%\%CL_TMP%Uniq.tmp > NUL
IF ERRORLEVEL 1 ECHO.| STRINS 1 "    %CL_ROW%"
GOTO SGTLoop
:SGTEnd
CALL FileUtil ReadTextRow Close %CL_STAT%
GOTO DelTmpFiles

:DelTmpFiles
IF EXIST %TMP%\%CL_TMP%*.tmp DEL %TMP%\%CL_TMP%*.tmp
GOTO End

:NoCfgErr
ECHO.
ECHO Error: configuration file "ChkLbCfg.bat" not found or not correct.
ECHO Execution aborted.
GOTO End

:NoStrUtilErr
ECHO.
ECHO Error: library "StrUtil.bat" not found.
ECHO Execution aborted.
GOTO End

:NoFileUtilErr
ECHO.
ECHO Error: library "FileUtil.bat" not found.
ECHO Execution aborted.
GOTO End

:NotFound
ECHO.
ECHO Error: "%1" not found.
ECHO Execution aborted.
GOTO End

:Help
ECHO.
ECHO Syntax:
ECHO   CHKLABEL {BatFileName} [/T]
ECHO.
ECHO Checks labels of {BatFileName} for  presence of spaces, for
ECHO uniqueness on whole length and on first 8 chars; if [/T] is
ECHO specified, then verifies if all GOTO's targets exist.
ECHO.
GOTO End

:End
